
<template>
  <el-container style="height: 100%">
    <el-header>
      <commonheader ></commonheader>
    </el-header>
    <el-container>
      <el-aside width="auto">
        <commonaside></commonaside>
      </el-aside>
      <div class="form-container">
        <el-main class="main">
          <h2 align="center"><strong> 新建商家 </strong></h2>
          <br>
          <el-form :model="ruleForm" :rules="rules" ref="ruleForm" label-width="120px">
            <el-form-item label="商家类型" prop="value">
              <el-select v-model="ruleForm.value" placeholder="请选择商家类型">
                <el-option style="width:100%"
                  v-for="item in options"
                  :key="item.value"
                  :label="item.label"
                  :value="item.value"
                >
                </el-option>
              </el-select>
            </el-form-item>
            <el-form-item label="商家名称" prop="shopname" label-width="120px">
              <el-col :span="8">
                <el-input v-model="ruleForm.shopname" placeholder="请输入商家名称"></el-input>
              </el-col>
            </el-form-item>
            <el-form-item label="商家简介"  prop="shopIntroduction" label-width="120px">
              <el-col :span="8">
                <el-input v-model="ruleForm.shopIntroduction" placeholder="请输入商家简介"></el-input>
              </el-col>
            </el-form-item>
            <el-form-item label="商家位置"  prop="shopLocation" label-width="120px">
              <el-col :span="8">
                <el-input v-model="ruleForm.shopLocation" placeholder="请输入商家位置"></el-input>
              </el-col>
            </el-form-item>
            <el-form-item label="上传商家图片" ref="uploadElement" prop="imageUrl">
              <br>
              <el-input v-model="ruleForm.imageUrl" v-if="false"></el-input>
              <el-upload
                class="avatar-uploader"
                ref="upload"
                :show-file-list="false"
                action="/index/upload"
                :before-upload="beforeUpload"
                :on-change="handleChange"
                :auto-upload="false"
                :data="ruleForm">
                <img v-if="ruleForm.imageUrl" :src="ruleForm.imageUrl" class="avatar">
                <i v-else class="el-icon-plus avatar-uploader-icon"></i>
              </el-upload>
            </el-form-item>
            <el-form-item style="margin-top: 100px">
              <el-row>
                <el-col :span="12">
                  <el-button type="primary"  @click="submitForm('ruleForm')" :disabled="ruleForm.disabled===true">新建</el-button>
                </el-col>
                <el-col :span="12">
                  <el-button type="danger"  @click="resetForm('ruleForm')" :disabled="ruleForm.disabled===true">重置</el-button>
                </el-col>
              </el-row>
            </el-form-item>
          </el-form>
        </el-main>
      </div>
    </el-container>
  </el-container>
</template>

<script>
import commonaside from '../components/commonaside.vue'
import commonheader from '../components/commonheader.vue'
import newshop from '../services/newshop'
export default {
  components: {
    commonaside,
    commonheader
  },
  name: 'newShop',
  data () {
    return {
      ruleForm: {
        imageUrl: '',
        value: 'key1',
        disabled: false,
        shopname: '',
        shopIntroduction: '',
        shopLocation: ''
      },
      rules: {
        imageUrl: [
          {required: true, message: '请上传商家图片', trigger: 'blur'}
        ],
        value: [
          {required: true, message: '请选择商家类型', trigger: 'blur'}
        ],
        shopname: [
          {
            required: true,
            message: '请输入商家名称'
          }
        ],
        shopLocation: [
          {
            required: true,
            message: '请输入商家位置'
          }
        ]
      },
      options: [{
        value: 'key1',
        label: '健身'
      }, {
        value: 'key2',
        label: '食品'
      }]
    }
  },
  created () {
    console.log(this.$store.state.roles)
    if (this.$store.state.token === '') {
      this.$router.go(-1)
      this.$message({
        showClose: true,
        message: '用户尚未登陆,无法新建商家,请先登陆……',
        type: 'error'
      })
    }
    if (this.$store.state.roles.indexOf('gymMerchant') === -1 &&
      this.$store.state.roles.indexOf('foodMerchant') === -1) {
      this.$router.push('/showviewinfo')
      this.$message({
        showClose: true,
        message: '未认证商家，请先认证商家',
        type: 'error'
      })
    } else if (this.$store.state.roles.indexOf('gymMerchant') === -1) {
      this.ruleForm.value = 'key2'
      this.options = [{
        value: 'key2',
        label: '食品'
      }]
    } else if (this.$store.state.roles.indexOf('foodMerchant') === -1) {
      this.options = [{
        value: 'key1',
        label: '健身'
      }]
    }
  },
  methods: {
    async submitForm (formName) {
      var flag = 0
      this.$refs.ruleForm.validate(valid => {
        if (!valid) {
          this.$message({
            message: '请填写必填项！',
            type: 'error'
          })
        } else {
          flag = 1
        }
      })
      if (flag) {
        try {
          this.ruleForm.disabled = true
          let response
          if (this.ruleForm.value === 'key1') {
            response = await newshop.postgym({
              shopName: this.ruleForm.shopname,
              shopIntroduction: this.ruleForm.shopIntroduction,
              shopLocation: this.ruleForm.shopLocation,
              shopImage: this.ruleForm.imageUrl,
              shopType: 'workout'
            },
            {
              headers: {'Authorization': this.$store.state.token}
            })
          } else if (this.ruleForm.value === 'key2') {
            response = await newshop.postfood({
              shopName: this.ruleForm.shopname,
              shopIntroduction: this.ruleForm.shopIntroduction,
              shopLocation: this.ruleForm.shopLocation,
              shopImage: this.ruleForm.imageUrl,
              shopType: 'food'
            },
            {
              headers: {'Authorization': this.$store.state.token}
            })
          }
          if (response.data.code === 200) {
            await this.$alert('商家添加成功！', '添加成功', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
                this.$router.push('/showviewinfo')
              }
            })
          } else {
            this.ruleForm.disabled = false
            this.error = response.data.msg
            await this.$alert(response.data.msg, '发送失败', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
              }
            })
          }
        } catch (error) {
          this.ruleForm.disabled = false
          if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
            this.error = 'Network Error'
            await this.$alert('Network Error', '发送失败', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
              }
            })
          } else {
            this.error = error.response.data.error
            if (error.response.data.code === 400) {
              await this.$alert('图片过大，不能超过64KB', '发送失败', {
                confirmButtonText: '确定',
                callback: action => {
                  this.$message({
                    type: 'info',
                    message: `action: ${action}`
                  })
                }
              })
            }
          }
        }
      }
    },
    resetForm (formName) {
      this.ruleForm.value = ''
      this.ruleForm.imageUrl = ''
    },
    handleChange (file, fileList) {
      var _this = this
      return new Promise(function (resolve, reject) {
        var reader = new FileReader()
        reader.readAsDataURL(file.raw)// 这里是最关键的一步，转换成base64
        reader.onload = function (event) {
          _this.ruleForm.imageUrl = event.target.result
          // console.log(this.ruleForm.imageUrl)
        }
      })
    },
    beforeUpload (file) {

    }
  }
}
</script>
<style scoped>
.avatar-uploader-icon {
  font-size: 40px;
  color: #8c939d;
  width: 200px;
  height: 200px;
  text-align: center;
}

.avatar {
  width: 200px;
  height: 200px;
  display: block;
}

.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}

.avatar-uploader .el-upload:hover {
  border-color: #409EFF;
}

.pwdbox{
    height:30px;
    width:225px;
    display: flex;
    margin-left:25px;
}

.background{
    width:600px;
    background-size:cover;
    background-image:url('../assets/food2.jpg');
    font-family:sans-serif;
}

.title{
    margin-top:320px;
    font-weight:bold;
    font-size:20px;
    color:#4E655D;
}

input{
    outline-style: none ;
    border: 0;
    border-bottom:1px solid #E9E9E9;
    background-color:transparent;
    height:20px;
    font-family:sans-serif;
    font-size:15px;
    color:#445b53;
    font-weight:bold;
}

.el-select {
  width: 200px;
}

input:focus{
    border-bottom:2px solid #445b53;
    background-color:transparent;
    transition: all 0.2s ease-in;
    font-family:sans-serif;
    font-size:15px;
    color:#445b53;
    font-weight:bold;
}

input:hover{
    border-bottom:2px solid #445b53;
    background-color:transparent;
    transition: all 0.2s ease-in;
    font-family:sans-serif;
    font-size:15px;
    color:#445b53;
    font-weight:bold;
    width:100%;
}

input:-webkit-autofill {
  /* 修改默认背景框的颜色 */
  box-shadow: 0 0 0px 1000px  #87CEFA inset !important;
 /* 修改默认字体的颜色 */
  -webkit-text-fill-color: #445b53;
}

input:-webkit-autofill::first-line {
  /* 修改默认字体的大小 */
  font-size: 15px;
 /* 修改默认字体的样式 */
  font-weight:bold;
}

.el-header {
    background-color: #333;
}
.form-container .main {
  display:table-cell;
  width:300px;
  background-color:#fff;
  padding:40px 60px;
  color:#505e6c
}
.form-container
{
  display:table;
  max-width:900px;
  width:90%;
  margin:0 auto;
  box-shadow:1px 1px 5px rgba(0,0,0,.1)
}
.form-container .el-row{
  margin-left: 30px;
  margin-top: 25px;
}
</style>
